import ij.*;
import ij.process.*;
import java.awt.*;
import ij.plugin.filter.*;

public class RGB_to_32Bit implements PlugInFilter {

ImageStack stack;
	public int setup(String arg, ImagePlus imp) { 
	stack = imp.getStack(); 
	return DOES_RGB; 
	}

public void run(ImageProcessor ip) {

	int w = stack.getWidth();
	int h = stack.getHeight();

	int[] pixels =(int[]) ip.getPixels();

	int v = 0;

	float[] R= new float[w*h];
	float[] G= new float[w*h]; 
	float[] B= new float[w*h]; 

	for(int j=0; j<w*h; j++){
		v = pixels[j];
		R[j] = (float) ((v>>16)&0xff);
		G[j] = (float) ((v>>8)&0xff);
		B[j] = (float) (v&0xff);
	}//j

	ImageStack outStack = new ImageStack(w, h);
	outStack.addSlice("R", R);
	outStack.addSlice("G", G);
	outStack.addSlice("B", B);
	new ImagePlus("Output", outStack).show();
}
}
